# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class CloudAccountExtended(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        CloudAccountExtended - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'account_username': 'str',
            'enabled': 'bool',
            'key': 'str',
            'name': 'str',
            'uri': 'str',
            'bucket': 'str',
            'id': 'str',
            'metadata_bucket': 'str',
            'pool': 'str',
            'type': 'str',
            'validity': 'str'
        }

        self.attribute_map = {
            'account_username': 'account_username',
            'enabled': 'enabled',
            'key': 'key',
            'name': 'name',
            'uri': 'uri',
            'bucket': 'bucket',
            'id': 'id',
            'metadata_bucket': 'metadata_bucket',
            'pool': 'pool',
            'type': 'type',
            'validity': 'validity'
        }

        self._account_username = None
        self._enabled = None
        self._key = None
        self._name = None
        self._uri = None
        self._bucket = None
        self._id = None
        self._metadata_bucket = None
        self._pool = None
        self._type = None
        self._validity = None

    @property
    def account_username(self):
        """
        Gets the account_username of this CloudAccountExtended.
        The username required to authenticate against the cloud service

        :return: The account_username of this CloudAccountExtended.
        :rtype: str
        """
        return self._account_username

    @account_username.setter
    def account_username(self, account_username):
        """
        Sets the account_username of this CloudAccountExtended.
        The username required to authenticate against the cloud service

        :param account_username: The account_username of this CloudAccountExtended.
        :type: str
        """
        
        self._account_username = account_username

    @property
    def enabled(self):
        """
        Gets the enabled of this CloudAccountExtended.
        Whether or not this account should be used for cloud storage

        :return: The enabled of this CloudAccountExtended.
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """
        Sets the enabled of this CloudAccountExtended.
        Whether or not this account should be used for cloud storage

        :param enabled: The enabled of this CloudAccountExtended.
        :type: bool
        """
        
        self._enabled = enabled

    @property
    def key(self):
        """
        Gets the key of this CloudAccountExtended.
        A valid authentication key for connecting to the cloud

        :return: The key of this CloudAccountExtended.
        :rtype: str
        """
        return self._key

    @key.setter
    def key(self, key):
        """
        Sets the key of this CloudAccountExtended.
        A valid authentication key for connecting to the cloud

        :param key: The key of this CloudAccountExtended.
        :type: str
        """
        
        self._key = key

    @property
    def name(self):
        """
        Gets the name of this CloudAccountExtended.
        A unique name for this account

        :return: The name of this CloudAccountExtended.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this CloudAccountExtended.
        A unique name for this account

        :param name: The name of this CloudAccountExtended.
        :type: str
        """
        
        self._name = name

    @property
    def uri(self):
        """
        Gets the uri of this CloudAccountExtended.
        A valid URI pointing to the location of the cloud storage

        :return: The uri of this CloudAccountExtended.
        :rtype: str
        """
        return self._uri

    @uri.setter
    def uri(self, uri):
        """
        Sets the uri of this CloudAccountExtended.
        A valid URI pointing to the location of the cloud storage

        :param uri: The uri of this CloudAccountExtended.
        :type: str
        """
        
        self._uri = uri

    @property
    def bucket(self):
        """
        Gets the bucket of this CloudAccountExtended.
        The machine generated name of the account bucket to store data

        :return: The bucket of this CloudAccountExtended.
        :rtype: str
        """
        return self._bucket

    @bucket.setter
    def bucket(self, bucket):
        """
        Sets the bucket of this CloudAccountExtended.
        The machine generated name of the account bucket to store data

        :param bucket: The bucket of this CloudAccountExtended.
        :type: str
        """
        
        self._bucket = bucket

    @property
    def id(self):
        """
        Gets the id of this CloudAccountExtended.
        A globally unique name for this account

        :return: The id of this CloudAccountExtended.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this CloudAccountExtended.
        A globally unique name for this account

        :param id: The id of this CloudAccountExtended.
        :type: str
        """
        
        self._id = id

    @property
    def metadata_bucket(self):
        """
        Gets the metadata_bucket of this CloudAccountExtended.
        The machine generated name of the account bucket to store metadata

        :return: The metadata_bucket of this CloudAccountExtended.
        :rtype: str
        """
        return self._metadata_bucket

    @metadata_bucket.setter
    def metadata_bucket(self, metadata_bucket):
        """
        Sets the metadata_bucket of this CloudAccountExtended.
        The machine generated name of the account bucket to store metadata

        :param metadata_bucket: The metadata_bucket of this CloudAccountExtended.
        :type: str
        """
        
        self._metadata_bucket = metadata_bucket

    @property
    def pool(self):
        """
        Gets the pool of this CloudAccountExtended.
        Name of the pool referencing this account.  Empty if none.

        :return: The pool of this CloudAccountExtended.
        :rtype: str
        """
        return self._pool

    @pool.setter
    def pool(self, pool):
        """
        Sets the pool of this CloudAccountExtended.
        Name of the pool referencing this account.  Empty if none.

        :param pool: The pool of this CloudAccountExtended.
        :type: str
        """
        
        self._pool = pool

    @property
    def type(self):
        """
        Gets the type of this CloudAccountExtended.
        The type of cloud protocol required (e.g., 'ran', 'azure')

        :return: The type of this CloudAccountExtended.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this CloudAccountExtended.
        The type of cloud protocol required (e.g., 'ran', 'azure')

        :param type: The type of this CloudAccountExtended.
        :type: str
        """
        allowed_values = ["ran", "azure"]
        if type is not None and type not in allowed_values:
            raise ValueError(
                "Invalid value for `type`, must be one of {0}"
                .format(allowed_values)
            )

        self._type = type

    @property
    def validity(self):
        """
        Gets the validity of this CloudAccountExtended.
        Either 'OK' or a message indicating problems with the account (Note* only shown when 'validate=1' argument is appended to URI)

        :return: The validity of this CloudAccountExtended.
        :rtype: str
        """
        return self._validity

    @validity.setter
    def validity(self, validity):
        """
        Sets the validity of this CloudAccountExtended.
        Either 'OK' or a message indicating problems with the account (Note* only shown when 'validate=1' argument is appended to URI)

        :param validity: The validity of this CloudAccountExtended.
        :type: str
        """
        
        self._validity = validity

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

